import _pt from 'prop-types'
import * as React from 'react'
const __reactCreateElement__ = React.createElement
import clsx from 'clsx'
import {Box} from './Box'
import {useLayout} from './Layout'
import {alignSelf} from './styles'
export const FlexItem = React.forwardRef(
  (
    {
      className,
      maxWidth,
      maxHeight,
      basis,
      order,
      grow,
      shrink,
      align,
      ...props
    },
    ref
  ) => {
    const prop = useLayout().mq.prop
    return /*#__PURE__*/ __reactCreateElement__(Box, {
      ref: ref,
      className: clsx(
        className,
        prop(maxWidthStyle, maxWidth),
        prop(maxHeightStyle, maxHeight),
        prop(basisStyle, basis),
        prop(orderStyle, order),
        prop(growStyle, grow),
        prop(shrinkStyle, shrink),
        prop(alignSelf, align)
      ),
      ...props,
    })
  }
)

const maxWidthStyle = (maxWidth) => ({
  maxWidth,
})

const maxHeightStyle = (maxHeight) => ({
  maxHeight,
})

const basisStyle = (basis) => ({
  basis,
})

const orderStyle = (order) => ({
  order,
})

const growStyle = (grow) => ({
  flexGrow: grow === true ? 1 : grow === false ? 0 : grow,
})

const shrinkStyle = (shrink) => ({
  flexShrink: shrink === true ? 1 : shrink === false ? 0 : shrink,
})
